'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'IIIIIIIIII       MOBILE ROBOT C-CONTROL II GATEWAY 2        IIIIIIIIII
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'
'Version 2.2 Dirk Ottensmeyer 04.10.2004
'
'Dieses Beispiel ladet einen neuen Treiber in das EEprom des Microcontrollers.
'Der Treiber untersttzt den Betrieb der Basiserweiterung (in diesem Fall die
'Ansteuerung der 8 LEDs welche die Basiserweiterung zur Verfgung stellt)
'Ausserdem stellt das Programm spezielle Routinen fr den Zugriff der C-Control II
'Unit auf die Systemresourcen des CCRP5 sicher
'
'This sample loads a new driver into the EEPROM of the microcontroller.
'The driver supports the operation of the Base Extension (in this case
'it drives the 8 LEDs on the Base Extension).
'Additionally the driver supports the access to the CCRP5 harware when
'you use a C-Control II Unit as main processor.
'
'---------------------------------------------------------------------
define UE60         155     'Akku-Entladespannung 6,0 V
'--------------------------
'------ I/O PORTS ---------
'--------------------------
define IO_port  byteport[1]
'- INTERFACE LCD/EXTPORT --
define sdio         port[1]
define sclio        port[3]
define strobe       port[4]
define LSTROBE      port[7]
'-- INTERFACE COM/NAV -----
define DATALINE     port[1]
define CLOCKLINE    port[2]
'-- CC2 INTERFACE   -------
define CC2POWER     port[8]
define NAVSTART     port[16]
'------ LCD INTERFACE ------
define lcd_port  byteport[2] 'Frei, wenn kein LCD angeschlossen ist!
define lcd_rs       port[14]
define lcd_rw       port[13]
define lcd_e        port[15]
'---------------------------
define lcd_db4      port[9]
define lcd_db5      port[10]
define lcd_db6      port[11]
define lcd_db7      port[12]
'--------------------------
'------ SENSORS ---------
'--------------------------
define FREIAD8      ad[8] 'Freier A/D-Wandler
define LIGHT_L      ad[7]
define LIGHT_R      ad[6]
define SYS_VOLTS    ad[3]
define CHRG_CURRENT ad[2]
define SYS_CURRENT  ad[1]
define MIC          ad[4]
define TOUCH        ad[5]
'---------------------------
'------  DRIVE -------------
'---------------------------
define SPEED_L        da[1]
define SPEED_R        da[2]
define REV_L        port[6]
define REV_R        port[5]
'--------------------------
'---- SYSTEM MEMORY -------
'--------------------------
'--- INTERFACE BUFFER ----
define LBYTE         byte[1]
define HBYTE         byte[2]
define SUBCMD        byte[3]
'---- OPERATION DATA ------
define EXTPORT       byte[4]
define LED1_F        bit[29]
define LED2_F        bit[30]
define LED3_F        bit[31]
define LED4_F        bit[32]
define SYSTEM_STATUS byte[5]
define ACSL_F        bit[33]
define ACSR_F        bit[34]
define IR_F          bit[35]
define LEDPORT       byte[6]
define L1_F          bit[41]
define L2_F          bit[42]
define L3_F          bit[43]
define L4_F          bit[44]
define L5_F          bit[45]
define L6_F          bit[46]
define L7_F          bit[47]
define L8_F          bit[48]
'---- LCD DRIVER -------------
define lcd_buf       byte[7] 'Bytes 7 und 8 frei, wenn LCD nicht genutzt wird!
define lcd_param     byte[8]
'--------------------------
'----  USER MEMORY  -------
'--------------------------
define CID           byte[9]
define GPR           byte[10]
define SEC           byte[11]
define MIN           byte[12]
define HR            byte[13]
define OLDSEC        byte[14]
define INWORD        word[12]
define READY         0
'--- SYSTEMROUTINEN -----------
define PLM_SLOW      &H01C2
define SYSTEM        &H01C7
define LED_DRIVE     &H01CA
define COMNAV        &H0144
'- ERWEITERTE SYSTEM ROUTINEN -
define REVR          &H0101   'ANTRIEB RECHTS RCKWRTS
define REVL          &H0106   'ANTRIEB LINKS RCKWRTS
define FWDR          &H010B   'ANTRIEG RECHTS VORWRTS
define FWDL          &H0110   'ANTRIEB LINKS VORWRTS
define ROTR          &H0115   'RECHTS DREHEN
define ROTL          &H0119   'LINKS DREHEN
define REV           &H011D   'RCKWRTS
define FWD           &H0121   'VORWRTS
define COMNAV_STATUS &H0125   'UPDATED ALLE FLAGS IM STATUS-REGISTER
define ACS_LO        &H01E0   'ACS POWER LO
define ACS_HI        &H01E8   '
define ACS_MAX       &H01F0   '
define SEND_TLM      &H013A   'SENDET TELEMETRIE (CH=HBYTE,DATEN=LBYTE)
define SEND_SYSSTAT  &H0134   'SENDET TLM KANAL 0,SYSTEM STATUS
                              '(FLAGS fr ACS,FWD/REV, ACS_LO/HI/MAX)

'---------- SUBSYS POWER ON--------------
gosub SUBSYS_PWR_ON
'---------- CC2 POWER ON ----------------
CC2POWER=on
'------- POSITIONING SYSTEM START -------
NAVSTART=off
'---------  DRIVE INIT ------------------
REV_L=off:REV_R=off:SYS PLM_SLOW
'-----------   LEDs INIT   --------------
EXTPORT=EXTPORT and &H0F:SYS SYSTEM:pulse STROBE
LEDPORT=0:SYS LED_DRIVE:pulse LSTROBE
'- SYSTEM OPERATION MODE (NO INTERRUPT) -
gosub NO_ACS_INT
'--------- IR-DATENFORMAT ---------------
'gosub RC5
'-------  SERIAL INTERFACE INIT  --------
#FLUSH
if not RXD then goto START
get CID:goto FLUSH
'HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH
'HHHHHHHHHHHHHHH  GATEWAY 2 COMMAND INTERPRETER  HHHHHHHHHHHHHHHHH
'HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH
#START
SUBCMD=3:sys COMNAV ' green LED flash

#LOOP
if not RXD then goto LOOP
get CID
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
if CID>4 then goto BLOCK2
if CID=0 then goto C0
if CID=1 then goto C1
if CID=2 then goto C2
if CID=3 then goto C3
if CID=4 then goto C4
#BLOCK2
if CID=5 then goto C5
if CID=6 then goto C6
if CID=7 then goto C7
if CID=8 then goto C8
if CID=9 then goto C9
if CID=10 then goto C10
#BLOCK3
if CID=11 then goto C11
if CID=12 then goto C12
if CID=13 then goto C13
if CID=14 then goto C14
if CID=15 then goto C15
#BLOCK4
if CID=16 then goto C16
if CID=17 then goto C17
if CID=18 then goto C18
if CID=19 then goto C19
if CID=20 then goto C20
#BLOCK5
if CID=21 then goto C21
if CID=22 then goto C22
if CID=23 then goto C23
if CID=24 then goto C24
if CID=25 then goto C25
#BLOCK6
if CID=26 then goto C26
if CID=27 then goto C27
if CID=28 then goto C28
if CID=29 then goto C29
if CID=30 then goto C30
#BLOCK7
if CID=31 then goto C31
if CID=32 then goto C32
if CID=33 then goto C33
if CID=34 then goto C34
if CID=35 then goto C35
#BLOCK8
if CID=36 then goto C36
if CID=37 then goto C37
if CID=38 then goto C38
if CID=39 then goto C39
if CID=40 then goto C40
goto LOOP

'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'IIIIIIIIIII COMMNAV STATUS ACCESS IIIIIIIII
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
#C0
sys COMNAV_STATUS:put SYSTEM_STATUS:goto LOOP
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'IIIIIII     DRIVE COMMANDS          IIIIIII
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
#C1
get SPEED_L:get SPEED_R:sys FWD:put READY:goto LOOP
#C2
get SPEED_L:get SPEED_R:sys REV:put READY:goto LOOP
#C3
get SPEED_L:get SPEED_R:sys ROTL:put READY:goto LOOP
#C4
get SPEED_L:get SPEED_R:sys ROTR:put READY:goto LOOP
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'IIIIII      SENSOR ACCESS              IIII
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
#C5'  AMBIENT SENSOR DATA
get CID:if CID=1 then goto C5x
put LIGHT_L:put LIGHT_R:put MIC:put TOUCH:goto LOOP
#C5x
SUBCMD=6:sys COMNAV:put HBYTE:put LBYTE
SUBCMD=7:sys COMNAV:put HBYTE:put LBYTE:goto LOOP
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'IIIIIIIIII     ACS ACCESS         IIIIIIIIII
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
#C6
get CID
EXTPORT=(EXTPORT and &HF9)or CID:sys SYSTEM:pulse STROBE:put READY:goto LOOP
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'IIIIIIIIII   IRCOMM ACCESS       IIIIIIIIIIII
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
#C7  'TRANSMIT
get HBYTE:get LBYTE:SUBCMD=0:sys COMNAV:put READY:goto LOOP
#C8  'RECEIVE
SUBCMD=1:sys COMNAV:put HBYTE:put LBYTE:goto LOOP
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'IIIIIIIIII  I/O - ACCESS              IIIIIIII
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
#C9  'LEDs 1-4 ON
get CID:get GPR
if GPR=0 then goto C9x
EXTPORT=EXTPORT or CID:sys SYSTEM:pulse STROBE:put READY:goto LOOP
#C9x  'LEDs 1-4 OFF
EXTPORT=EXTPORT and CID:sys SYSTEM:pulse STROBE:put READY:goto LOOP
'-----------------------------------------------
#C10   'L1-8 ON
get CID:get GPR
if GPR=0 then goto C10x
LEDPORT=LEDPORT or CID:sys LED_DRIVE:pulse LSTROBE:put READY:goto LOOP
#C10x  'L1-8 OFF
LEDPORT=LEDPORT and CID:sys LED_DRIVE:pulse LSTROBE:put READY:goto LOOP
#C11   'BEEP
get CID:get GPR:INWORD= GPR*256+CID:get CID:beep INWORD,CID,0:put READY:goto LOOP
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'IIIIIIIIII  CCRP 5 CONTROLS           IIIIIIII
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII

#C12'CLEAR DISTANCE COUNTER
SUBCMD=3:sys COMNAV:put READY:goto LOOP
#C13'SET RC5
SUBCMD=4:sys COMNAV:LBYTE= HBYTE and &HFC
HBYTE=00:SUBCMD=2:sys COMNAV:put READY:goto LOOP
#C14'SET REC80
SUBCMD=4:sys COMNAV:LBYTE= (HBYTE or &H01)and &HFD
HBYTE=00:SUBCMD=2:sys COMNAV:put READY:goto LOOP
#C15'SET REALTIME CLOCK
get HOUR:get MINUTE:get SECOND:put READY:goto LOOP
#C16'SEND RTC
put HOUR:put MINUTE:put SECOND:goto LOOP

'------------------------------------------------
'------- ENTER/EXIT SYSTEM SLEEP MODE  ----------
'------------------------------------------------
#C17'SLEEP
get HR:get MIN:put READY
gosub SUBSYS_PWR_OFF:CC2POWER=off
'------ SYSTEM WAKE TIMER ----------------------
#tst
SEC=0:OLDSEC=SECOND
#WTS
if SECOND = OLDSEC then goto WTS
OLDSEC=SECOND:SEC=SEC+1
if SEC<>60 then goto WTS
SEC=0:MIN=MIN-1:beep 368,1,0
if SYS_VOLTS < UE60 then goto WAKEUP 'Akku leer!
if MIN<>0 then goto WTS
if HR=0 then goto WAKEUP
HR=HR-1:MIN=59:goto WTS
'----- WAKE SYSTEM ----------------------------
#WAKEUP 'CC2 UND Subsysteme EINschalten!
gosub SUBSYS_PWR_ON
#WAKE_CC2 'NUR CC2 EINschalten!
beep 368,5,5:beep 368,5,5:beep 368,5,5:CC2POWER=on
'----- WAITING FOR CC2 IS WAKE BYTE -----------
get HR:put 1:goto LOOP
'-------------------------------------------------
'------------ RESPONSE TEST ----------------------
'-------------------------------------------------
#C18'RESPONSE TEST
put 0:goto LOOP
'---------------------------------------------
'----- DATA SAVE/RECALL TO EEPROM ------------
'---------------------------------------------
#C19'READ/WRITE DATA TO EEPROM
get CID
on CID goto CLOSE,WOPEN,ROPEN,FWRITE,FREAD
#CLOSE
close#:put READY:goto LOOP
#WOPEN
open# for write:put READY:goto LOOP
#ROPEN
open# for read:put READY:goto LOOP
#FWRITE
get GPR:get INWORD:INWORD=(INWORD shl 8)+ GPR:print# INWORD:put READY:goto LOOP
#FREAD
input# INWORD:put INWORD:put (INWORD shr 8):goto LOOP
#C20'HOUSEKEEPING DATA
put SYS_VOLTS:put SYS_CURRENT:put CHRG_CURRENT:put READY:goto LOOP
'---------------------------------------------
'Erweiterter Befehlssatz Gateway 2:
#C21 'FWDL
get SPEED_L:sys FWDL:put READY:goto LOOP

#C22 'FWDR
get SPEED_R:sys FWDR:put READY:goto LOOP

#C23 'REVL
get SPEED_L:sys REVL:put READY:goto LOOP

#C24 'REVR
get SPEED_R:sys REVR:put READY:goto LOOP

#C25 'AD[8]-Abfrage
put FREIAD8:goto LOOP

#C26 'Subsystem Mode einstellen
get LBYTE:SUBCMD=2:sys COMNAV:put READY:goto LOOP

#C27 'Subsystem Mode lesen
SUBCMD=4:sys COMNAV:put HBYTE:goto LOOP

#C28 'Set Device Address
get LBYTE:SUBCMD=5:sys COMNAV:put READY:goto LOOP

#C29 'LCD1-Funktion: INIT
gosub LCD_INIT:put READY:goto LOOP

#C30 'LCD1-Funktion: CLS
gosub LCD_CLS:put READY:goto LOOP

#C31 'LCD1-Funktion: Zeile 1/2, Zeichenausgabe
get lcd_param:if lcd_param=1 or lcd_param=2 then goto C3112
gosub LCD_WRITECHAR:put READY:goto LOOP
#C3112
gosub LCD_GOTOLINE:put READY:goto LOOP

#C32 'CC1-Ports[1..16] lesen
put IO_port:put lcd_port:goto LOOP

#C33 'CC1-Port[1..16] pulsen/deaktivieren
get CID:get GPR
on CID goto C330,C331,C332,C333,C334,C335,C336,C337,C338,C339,C3310,C3311,C3312,C3313,C3314,C3315,C3316
#C330
goto LOOP
#C331 'sdio nicht deaktivieren!
if GPR <> 0 then pulse sdio
goto LOOP
#C332 'CLOCKLINE nicht deaktivieren!
if GPR <> 0 then pulse CLOCKLINE
goto LOOP
#C333 'sclio nicht deaktivieren!
if GPR <> 0 then pulse sclio
goto LOOP
#C334 'strobe nicht deaktivieren!
if GPR <> 0 then pulse strobe
goto LOOP
#C335 'REV_R nicht pulsen/deaktivieren!
goto LOOP
#C336 'REV_L nicht pulsen/deaktivieren!
goto LOOP
#C337 'LSTROBE nicht deaktivieren!
if GPR <> 0 then pulse LSTROBE
goto LOOP
#C338 'CC2POWER nicht pulsen/deaktivieren!
goto LOOP
#C339
if GPR = 0 then deact lcd_db4 else pulse lcd_db4
goto LOOP
#C3310
if GPR = 0 then deact lcd_db5 else pulse lcd_db5
goto LOOP
#C3311
if GPR = 0 then deact lcd_db6 else pulse lcd_db6
goto LOOP
#C3312
if GPR = 0 then deact lcd_db7 else pulse lcd_db7
goto LOOP
#C3313
if GPR = 0 then deact lcd_rw else pulse lcd_rw
goto LOOP
#C3314
if GPR = 0 then deact lcd_rs else pulse lcd_rs
goto LOOP
#C3315
if GPR = 0 then deact lcd_e else pulse lcd_e
goto LOOP
#C3316
if GPR = 0 then deact NAVSTART else pulse NAVSTART
goto LOOP

#C34 'CC1-Port[1..16] setzen/lschen
get CID:get GPR
on CID goto C340,C341,C342,C343,C344,C345,C346,C347,C348,C349,C3410,C3411,C3412,C3413,C3414,C3415,C3416
#C340
goto LOOP
#C341
if GPR = 0 then sdio=off else sdio=on
goto LOOP
#C342
if GPR = 0 then CLOCKLINE=off else CLOCKLINE=on
goto LOOP
#C343
if GPR = 0 then sclio=off else sclio=on
goto LOOP
#C344
if GPR = 0 then strobe=off else strobe=on
goto LOOP
#C345
if GPR = 0 then REV_R=off else REV_R=on
goto LOOP
#C346
if GPR = 0 then REV_L=off else REV_L=on
goto LOOP
#C347
if GPR = 0 then LSTROBE=off else LSTROBE=on
goto LOOP
#C348 'CC2POWER nicht setzen/lschen!
goto LOOP
#C349
if GPR = 0 then lcd_db4=off else lcd_db4=on
goto LOOP
#C3410
if GPR = 0 then lcd_db5=off else lcd_db5=on
goto LOOP
#C3411
if GPR = 0 then lcd_db6=off else lcd_db6=on
goto LOOP
#C3412
if GPR = 0 then lcd_db7=off else lcd_db7=on
goto LOOP
#C3413
if GPR = 0 then lcd_rw=off else lcd_rw=on
goto LOOP
#C3414
if GPR = 0 then lcd_rs=off else lcd_rs=on
goto LOOP
#C3415
if GPR = 0 then lcd_e=off else lcd_e=on
goto LOOP
#C3416
if GPR = 0 then NAVSTART=off else NAVSTART=on
goto LOOP

#C35 'SET REALTIME DATE
get YEAR:get MONTH:get DAY:put READY:goto LOOP

#C36 'SEND RTC DATE
put YEAR:put MONTH:put DAY:goto LOOP

#C37 'SLEEP WITH A WAKEUP CONDITION
get CID:get GPR:put READY
CC2POWER=off 'CC2 AUSschalten!!!
on GPR goto WC0,WC1,WC2,WC3,WC4,WC5,WC6,WC7,WC8,WC9,WC10,WC11,WC12,WC13
'------ SYSTEM WAKE CONDITIONS ----------------
' HINWEIS: Im Sleep-Modus wird IMMER auf die ENTLADESPANNUNG des Akkus
' (6,0V => SYS_VOLTS < UE60) getestet und bei entladenem Akku ein Wakeup
' der CC2 herbeigefhrt. Somit wird verhindert, dass der Robby im Sleep-
' Modus stromlos wird, ohne sinnvolle Gegenmanahmen ergreifen zu knnen.
' Die CC2 sollte nach jedem Wakeup zunchst immer SYS_VOLTS prfen!
#WC0 'Niedrige Akkuspannung (SYS_VOLTS < CID)
gosub SUBSYS_PWR_OFF 'Subsysteme AUSschalten
#WC0SLEEP 'VORSICHT: CID sollte >= UE60 sein!
if SYS_VOLTS < CID then goto WAKEUP
pause 20:goto WC0SLEEP

#WC1 'Ladeendspannung (SYS_VOLTS > CID)
gosub SUBSYS_PWR_OFF
#WC1SLEEP
if SYS_VOLTS < UE60 or SYS_VOLTS > CID then goto WAKEUP
pause 20:goto WC1SLEEP

#WC2 'Ladestrom niedrig ((CHRG_CURRENT-SYS_VOLTS) < CID)
gosub SUBSYS_PWR_OFF
#WC2SLEEP
GPR=CHRG_CURRENT-SYS_VOLTS:if GPR > 250 then GPR=0
if SYS_VOLTS < UE60 or GPR < CID then goto WAKEUP
pause 20:goto WC2SLEEP

#WC3 'Ladestrom hoch ((CHRG_CURRENT-SYS_VOLTS) > CID)
gosub SUBSYS_PWR_OFF
#WC3SLEEP
GPR=CHRG_CURRENT-SYS_VOLTS:if GPR > 250 then GPR=0
if SYS_VOLTS < UE60 or GPR > CID then goto WAKEUP
pause 20:goto WC3SLEEP

#WC4 'Gerusch (MIC > CID)
gosub SUBSYS_PWR_OFF
#WC4SLEEP
MIN=0: for GPR=0 to 99
 SEC=MIC:if SEC > MIN then MIN=SEC
next
if SYS_VOLTS < UE60 or MIN > CID then goto WAKEUP
pause 20:goto WC4SLEEP

#WC5 'Berhrung (TOUCH > CID)
gosub SUBSYS_PWR_OFF
#WC5SLEEP
if SYS_VOLTS < UE60 or TOUCH > CID then goto WAKEUP
pause 20:goto WC5SLEEP

#WC6 'Dunkelheit (LIGHT_R/L < CID)
gosub SUBSYS_PWR_OFF
#WC6SLEEP
if SYS_VOLTS < UE60 or LIGHT_L < CID or LIGHT_R < CID then goto WAKEUP
pause 20:goto WC6SLEEP

#WC7 'Helligkeit (LIGHT_R/L > CID)
gosub SUBSYS_PWR_OFF
#WC7SLEEP
if SYS_VOLTS < UE60 or LIGHT_L > CID or LIGHT_R > CID then goto WAKEUP
pause 20:goto WC7SLEEP

#WC8 'AD[8] < CID
gosub SUBSYS_PWR_OFF
#WC8SLEEP
if SYS_VOLTS < UE60 or FREIAD8 < CID then goto WAKEUP
pause 20:goto WC8SLEEP

#WC9 'AD[8] > CID
gosub SUBSYS_PWR_OFF
#WC9SLEEP
if SYS_VOLTS < UE60 or FREIAD8 > CID then goto WAKEUP
pause 20:goto WC9SLEEP

#WC10 'ACS R/L angesprochen (CID[0..2]: Power LO/HI/MAX)
on CID goto ACSPLO,ACSPHI,ACSPMAX
#ACSPLO 'CID=0
sys ACS_LO:goto WC10SLEEP
#ACSPHI 'CID=1
sys ACS_HI:goto WC10SLEEP
#ACSPMAX 'CID=2
sys ACS_MAX
#WC10SLEEP
sys COMNAV_STATUS
if SYS_VOLTS < UE60 or ACSL_F or ACSR_F then goto WAKE_CC2
pause 20:goto WC10SLEEP

#WC11 'IR-Signal empfangen (CID: RC5-Wakeup-CMD)
sys COMNAV_STATUS
if SYS_VOLTS < UE60 then goto WAKE_CC2
if IR_F then goto GOT_IR
pause 20:goto WC11
#GOT_IR
gosub GET_IRDATA:if LBYTE = CID then goto WAKE_CC2
beep 368,5,5:pause 15:goto WC11

#WC12 'Aktuelles DCF-Signal empfangen (CID[1..255]: Min. bis Abbruch)
gosub SUBSYS_PWR_OFF
SEC=0:OLDSEC=SECOND:YEAR=97 'Jahr zurcksetzen!
#WC12SLEEP
if SECOND = OLDSEC then goto WC12SLEEP
OLDSEC=SECOND:SEC=SEC+1
if SEC <> 60 then goto WC12SLEEP
SEC=0:CID=CID-1:beep 368,1,0
if CID = 0 or SYS_VOLTS < UE60 or YEAR <> 97 then goto WAKEUP
goto WC12SLEEP

#WC13 'Eigenes Programm ausfhren (CID[0..xx]: Programm-Nr.)
'on CID goto WC130,WC131,WC132,WC133,WC134,WC135,WC136,WC137,...,WC13xx
#WC130 'Rahmen fr ein eigenes Programm (hier: Nr. 0)
'gosub SUBSYS_PWR_OFF 'Subsystem ausschalten, falls nicht bentigt
'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
' Hier kann ein eigenes Programm stehen. Es darf auf die Ressourcen des
' Robby zurckgreifen, auch auf das LC-Display am Stecker LCD1, jedoch
' NICHT die CC2 einschalten (CC2POWER=on). ACS und IR-COMM sollten nicht
' im Interrupt-Modus betrieben werden, der IR-Modus mu RC5 bleiben.
' Hier kann man auch ein Men programmieren, wobei man z.B. mit einer
' IR-Fernbedienung zwischen den Programmen auswhlen kann. Alternativ
' erfolgt die Programmauswahl vorab durch die CC2 (Parameter CID, s.o.!).
' Die CC2 kann die Kontrolle erst wieder bernehmen, wenn das Programm
' hier mit einer eigenen Abbruchbedingung endet. Der Abbruch darf IMMER
' nur ber das unten angefhrte Programmende erfolgen. Dann bernimmt
' die CC2 wieder die Kontrolle.
' Programm:

'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
' Programmende:
pause 100 'Kann entfallen, wenn ein eigenes Programm eingefgt wurde
goto WAKE_CC2 'goto WAKEUP 'falls das Subsystem ausgeschaltet war

'------ SYSTEM WAKE CONDITIONS END ------------

#C38 'Auf Ping warten
SUBCMD=8:sys COMNAV:put LBYTE:goto LOOP

#C39 'File-Status: EOF?
if EOF then goto READ_END
put 0:goto LOOP
#READ_END
put &HFF:goto LOOP

#C40 'File-Status: FILEFREE?
if FILEFREE < 1 then goto WRITE_END
put &HFF:goto LOOP
#WRITE_END
put 0:goto LOOP

'----------------------------------------
'------------- LCD ROUTINES -------------
'----------------------------------------
#LCD_INIT
' alle ports 0
  lcd_port = OFF

' 8-Bit-Modus aktivieren
  lcd_param=&H38 : gosub LCD_WRITECMD

' mit 8-Bit-Command in 4-Bit-Modus umschalten
  lcd_port=&B00000010
  tog lcd_e
  tog lcd_e

' ab jetzt 4-Bit-Modus
  lcd_param = &H28 : gosub LCD_WRITECMD
  lcd_param = &H0C : gosub LCD_WRITECMD

' Display loeschen
#LCD_CLS
  lcd_param = &H02 : gosub LCD_WRITECMD
  lcd_param = &H01 : gosub LCD_WRITECMD
return

' Zeilenwechsel
#LCD_GOTOLINE
  if lcd_param = 1 then lcd_param = &H80
  if lcd_param = 2 then lcd_param = &HC0
  goto LCD_WRITECMD

' LCD-Kommando
#LCD_WRITECMD
  lcd_buf = OFF
  goto LCD_WRITE

' Zeichenausgabe
#LCD_WRITECHAR
  lcd_buf = &B00100000

' Kommando oder Zeichen an Display senden
#LCD_WRITE
  lcd_port = lcd_buf or (lcd_param shr 4) ' Hi-Nibble
  tog lcd_e
  tog lcd_e
  lcd_port = lcd_buf or (lcd_param and &H0F)  ' Lo-Nibble
  tog lcd_e
  tog lcd_e
return

'---------------------------------------------
'--- LEDS AUF DER BASIS ERWEITERUNG  ------
'----------------------------------------------------------------
#GET_IRDATA
SUBCMD=1:sys COMNAV:return
#RC5
SUBCMD=4:sys COMNAV:LBYTE= HBYTE and &HFC
HBYTE=00:SUBCMD=2:sys COMNAV:return
#NO_ACS_INT
SUBCMD=4:sys COMNAV:LBYTE= HBYTE and &HFB
HBYTE=00:SUBCMD=2:sys COMNAV:return
#SUBSYS_PWR_ON
sdio=on:sclio=on:strobe=off:LSTROBE=off:EXTPORT=(EXTPORT and &HFE)or 8
sys SYSTEM:pulse STROBE:return
#SUBSYS_PWR_OFF
EXTPORT=(EXTPORT and &HF7)or 1:sys SYSTEM:pulse STROBE
deact sdio:deact sclio:return
'---------COM/NAV GERTEREIBER -------------
'                 syscode "p5driv12.s19"
